//----------------------------------------------------------------------
/// \brief Generiert ein Intel HexFile fr Speicher
/// \author Philipp Kaelin
/// \date Created: 2009-12-12
/// \date Modifyd: 2009-12-15
//----------------------------------------------------------------------

#ifndef _HEXGENERATOR_H_
#define _HEXGENERATOR_H_

  //************
  //* Includews
  //************
  #include <stdint.h>
  
  
  //***********************
  //* Funbction Prototypes
  //***********************

  /// \brief 
  /// Loescht den gesamten HexBuffer
  /// \param
  /// setting Wert mit welchen der Buffer gefuellt werden soll
  void clearBuffer ( uint8_t fillValue );
  
  /// \brief
  /// Schreibt ein Datenbyte an die naechste freie Stelle im Buffer
  /// \param
  /// value DatenByte das geschrieben werden soll
  void writeBuffer ( uint8_t value );
  
  /// \brief
  /// Schreibt ein Datenbyte an eine spezifizierte Adresse im Buffer
  /// \param
  /// byteAdress Adresse an welche geschrieben werden soll
  /// \param
  /// value DatenByte das geschrieben werden soll
  /// \warning
  ///
  void writeBufferAdress ( uint32_t byteAdress, uint8_t value );
  
  /// \brief
  /// Legt die oberste Adresse des Speichers fest
  /// (Bis zu dieser Adresse wir das HexFile erstellt)
  /// \param 
  /// topAdress Oberste Adresse
  void setBufferTop ( uint32_t topAdress );
  
  /// \param
  /// filename String mit Dateiname z.B. "output.hex"
  /// \return
  /// 0 wenn erfolgreich
  /// 1 Fehler beim oeffnen der Datei
  int generateHexFile ( const char *filename );
  
#endif // _HEXGENERATOR_H_
